#ifndef __FATORRGCONVERTER_H__
#define __FATORRGCONVERTER_H__

#include <grammar/Regular/RightRG.h>
#include <automaton/FSM/NFA.h>

namespace fa2rg
{

/**
 * Finite automaton to right regular grammar converter.
 * Source: Melichar 2.104
 */
class FAtoRRGConverter
{
public:
    /**
     * Performs conversion.
     * @return left regular grammar equivalent to source automaton.
     */
    grammar::RightRG convert(const automaton::NFA& automaton);

private:
    bool isSymbolOnAnyRightHandSide(const alphabet::Symbol& symbol, const grammar::RightRG& grammar) const;
};

} /* namespace fa2rg */

#endif /* __FATORRGCONVERTER_H__ */
